.386

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE

INCLUDE    \masm32\include\windows.inc
INCLUDE    \masm32\include\user32.inc
INCLUDE    \masm32\include\kernel32.inc
INCLUDE    \masm32\include\comctl32.inc
INCLUDELIB \masm32\lib\comctl32.lib
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\kernel32.lib

WinMain PROTO :DWORD, :DWORD, :DWORD, :DWORD

RGB MACRO red, green, blue
    mov eax, red + (green SHL 8) + (blue SHL 16)
ENDM

.CONST

IDM_MAINMENU  EQU 10000
IDM_ICON      EQU LVS_ICON
IDM_SMALLICON EQU LVS_SMALLICON
IDM_LIST      EQU LVS_LIST
IDM_REPORT    EQU LVS_REPORT

.DATA

ClassName         DB "ListViewWinClass", 0
AppName           DB "Testowanie kontrolki widoku listy", 0
ListViewClassName DB "SysListView32", 0
Heading1          DB "Nazwa pliku", 0
Heading2          DB "Rozmiar", 0
FileNamePattern   DB "*.*", 0
template          DB "%lu", 0
FileNameSortOrder DD 0
SizeSortOrder     DD 0

.DATA?

hInstance HINSTANCE ?
hList     DD ?
hMenu     DD ?

.CODE

start:

    INVOKE GetModuleHandle, NULL
    mov    hInstance, eax
    INVOKE WinMain, hInstance, NULL, NULL, SW_SHOWDEFAULT
    INVOKE ExitProcess, eax
    INVOKE InitCommonControls

WinMain PROC hInst:     HINSTANCE,
             hPrevInst: HINSTANCE,
             CmdLine:   LPSTR,
             CmdShow:   DWORD

LOCAL wc:   WNDCLASSEX
LOCAL msg:  MSG
LOCAL hwnd: HWND

    mov    wc.cbSize, SIZEOF WNDCLASSEX
    mov    wc.style, NULL
    mov    wc.lpfnWndProc, OFFSET WndProc
    mov    wc.cbClsExtra, NULL
    mov    wc.cbWndExtra, NULL
    push   hInstance
    pop    wc.hInstance
    mov    wc.hbrBackground, COLOR_WINDOW+1
    mov    wc.lpszMenuName, IDM_MAINMENU
    mov    wc.lpszClassName, OFFSET ClassName
    INVOKE LoadIcon, NULL, IDI_APPLICATION
    mov    wc.hIcon, eax
    mov    wc.hIconSm, eax
    INVOKE LoadCursor, NULL, IDC_ARROW
    mov    wc.hCursor, eax
    INVOKE RegisterClassEx, ADDR wc
    INVOKE CreateWindowEx, NULL, ADDR ClassName, ADDR AppName,
           WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,
           CW_USEDEFAULT, 400, 300, NULL, NULL,
           hInst, NULL
    mov    hwnd, eax
    INVOKE ShowWindow, hwnd, SW_SHOWNORMAL
    INVOKE UpdateWindow, hwnd

    .WHILE TRUE
        INVOKE GetMessage, ADDR msg, NULL, 0, 0
        .BREAK .IF (!eax)
        INVOKE TranslateMessage, ADDR msg
        INVOKE DispatchMessage, ADDR msg
    .ENDW

    mov eax, msg.wParam
    ret

WinMain ENDP

InsertColumn PROC

LOCAL lvc: LV_COLUMN

    mov    lvc.imask, LVCF_TEXT + LVCF_WIDTH
    mov    lvc.pszText, OFFSET Heading1
    mov    lvc.lx, 150
    INVOKE SendMessage, hList, LVM_INSERTCOLUMN, 0, ADDR lvc
    or     lvc.imask, LVCF_FMT
    mov    lvc.fmt, LVCFMT_RIGHT
    mov    lvc.pszText, OFFSET Heading2
    mov    lvc.lx, 100
    INVOKE SendMessage, hList, LVM_INSERTCOLUMN, 1 , ADDR lvc    
    ret        

InsertColumn ENDP

ShowFileInfo PROC USES edi row:DWORD, lpFind:DWORD

LOCAL lvi:        LV_ITEM
LOCAL buffer[20]: BYTE

    mov edi, lpFind

ASSUME edi: PTR WIN32_FIND_DATA

    mov    lvi.imask, LVIF_TEXT + LVIF_PARAM
    push   row
    pop    lvi.iItem    
    mov    lvi.iSubItem, 0
    lea    eax, [edi].cFileName
    mov    lvi.pszText, eax
    push   row
    pop    lvi.lParam
    INVOKE SendMessage, hList, LVM_INSERTITEM, 0, ADDR lvi
    mov    lvi.imask, LVIF_TEXT
    inc    lvi.iSubItem
    INVOKE wsprintf, ADDR buffer, ADDR template, [edi].nFileSizeLow
    lea    eax, buffer
    mov    lvi.pszText, eax
    INVOKE SendMessage, hList, LVM_SETITEM, 0, ADDR lvi

ASSUME edi: NOTHING

    ret

ShowFileInfo ENDP

FillFileInfo PROC USES edi

LOCAL finddata: WIN32_FIND_DATA
LOCAL FHandle:  DWORD

    INVOKE FindFirstFile, ADDR FileNamePattern, ADDR finddata
    .IF eax!=INVALID_HANDLE_VALUE
        mov FHandle, eax
        xor edi, edi

        .WHILE eax!=0
            test finddata.dwFileAttributes, FILE_ATTRIBUTE_DIRECTORY
            .IF ZERO?
                INVOKE ShowFileInfo, edi, ADDR finddata
                inc    edi
            .ENDIF
            INVOKE FindNextFile, FHandle, ADDR finddata
        .ENDW

        INVOKE FindClose, FHandle
    .ENDIF
    ret

FillFileInfo ENDP

String2Dword PROC USES esi String:DWORD

    mov esi, String
    xor eax, eax
    
lp1:

    movzx  ecx, BYTE PTR [esi]
    inc    esi
    or     ecx, ecx
    jz     exit
    imul   eax, 10
    add    eax, ecx
    sub    eax, "0"
    jmp    lp1
    
exit:

    ret
    
String2Dword ENDP


CompareFunc PROC USES edi lParam1:DWORD, lParam2:DWORD, SortType:DWORD

LOCAL buffer[256]:  BYTE
LOCAL buffer1[256]: BYTE
LOCAL lvi:          LV_ITEM

    mov lvi.imask, LVIF_TEXT
    lea eax, buffer
    mov lvi.pszText, eax
    mov lvi.cchTextMax, 256
    .IF (SortType==1) || (SortType==2)
        mov    lvi.iSubItem, 1
        INVOKE SendMessage, hList, LVM_GETITEMTEXT, lParam1, ADDR lvi
        INVOKE String2Dword, ADDR buffer
        mov    edi, eax
        INVOKE SendMessage, hList, LVM_GETITEMTEXT, lParam2, ADDR lvi
        INVOKE String2Dword, ADDR buffer
        .IF SortType==1
            sub edi, eax
            mov eax, edi
        .ELSE
            sub eax, edi
        .ENDIF
    .ELSE
        mov    lvi.iSubItem, 0
        INVOKE SendMessage, hList, LVM_GETITEMTEXT, lParam1, ADDR lvi
        INVOKE lstrcpy, ADDR buffer1, ADDR buffer
        INVOKE SendMessage, hList, LVM_GETITEMTEXT, lParam2, ADDR lvi
        .IF SortType==3
            INVOKE lstrcmpi, ADDR buffer1, ADDR buffer
        .ELSE
            INVOKE lstrcmpi, ADDR buffer, ADDR buffer1
        .ENDIF
    .ENDIF

    ret

CompareFunc ENDP

UpdatelParam PROC USES edi

LOCAL lvi: LV_ITEM

    INVOKE SendMessage, hList, LVM_GETITEMCOUNT, 0, 0
    mov    edi, eax
    mov    lvi.imask, LVIF_PARAM
    mov    lvi.iSubItem, 0
    mov    lvi.iItem, 0

    .WHILE edi>0
        push   lvi.iItem
        pop    lvi.lParam
        INVOKE SendMessage, hList, LVM_SETITEM, 0, ADDR lvi
        inc    lvi.iItem
        dec    edi
    .ENDW

    ret

UpdatelParam ENDP

ShowCurrentFocus PROC

LOCAL lvi:         LV_ITEM
LOCAL buffer[256]: BYTE

    INVOKE SendMessage, hList, LVM_GETNEXTITEM, -1, LVNI_FOCUSED
    mov    lvi.iItem, eax
    mov    lvi.iSubItem, 0
    mov    lvi.imask, LVIF_TEXT
    lea    eax, buffer
    mov    lvi.pszText, eax
    mov    lvi.cchTextMax, 256
    INVOKE SendMessage, hList, LVM_GETITEM, 0, ADDR lvi
    INVOKE MessageBox, 0, ADDR buffer, ADDR AppName, MB_OK
    ret

ShowCurrentFocus ENDP

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    .IF uMsg==WM_CREATE
        INVOKE CreateWindowEx, NULL, ADDR ListViewClassName, NULL,
                               LVS_REPORT + WS_CHILD + WS_VISIBLE,
                               0, 0, 0, 0, hWnd, NULL, hInstance, NULL
        mov    hList, eax
        INVOKE InsertColumn
        INVOKE FillFileInfo
        RGB    255, 255, 255
        INVOKE SendMessage, hList, LVM_SETTEXTCOLOR, 0, eax
        RGB    0, 0, 0
        INVOKE SendMessage, hList, LVM_SETBKCOLOR, 0, eax
        RGB    0, 0, 0
        INVOKE SendMessage, hList, LVM_SETTEXTBKCOLOR, 0, eax
        INVOKE GetMenu, hWnd
        mov    hMenu, eax
        INVOKE CheckMenuRadioItem, hMenu, IDM_ICON, IDM_LIST,
                                   IDM_REPORT, MF_CHECKED
    .ELSEIF uMsg==WM_COMMAND
        .IF lParam==0
            INVOKE GetWindowLong, hList, GWL_STYLE
            and    eax, NOT LVS_TYPEMASK
            or     ax, WORD PTR wParam
            INVOKE SetWindowLong, hList, GWL_STYLE, eax
            movzx  eax, WORD PTR wParam
            INVOKE CheckMenuRadioItem, hMenu, IDM_ICON,
                                       IDM_LIST, eax, MF_CHECKED
        .ENDIF
    .ELSEIF uMsg==WM_NOTIFY
        push edi
        mov  edi, lParam

ASSUME edi: PTR NMHDR

        mov eax, [edi].hwndFrom
        .IF eax==hList
            .IF [edi].code==LVN_COLUMNCLICK

ASSUME edi: PTR NM_LISTVIEW                

                .IF [edi].iSubItem==1
                    .IF SizeSortOrder==0 || SizeSortOrder==2
                        INVOKE SendMessage, hList, LVM_SORTITEMS, 1,
                                            ADDR CompareFunc
                        INVOKE UpdatelParam
                        mov    SizeSortOrder, 1
                    .ELSE
                        INVOKE SendMessage, hList, LVM_SORTITEMS, 2,
                                            ADDR CompareFunc
                        INVOKE UpdatelParam
                        mov    SizeSortOrder, 2
                    .ENDIF                    
                .ELSE
                    .IF FileNameSortOrder==0 || FileNameSortOrder==4
                        INVOKE SendMessage, hList, LVM_SORTITEMS, 3,
                                            ADDR CompareFunc
                        INVOKE UpdatelParam
                        mov    FileNameSortOrder, 3
                    .ELSE
                        INVOKE SendMessage, hList, LVM_SORTITEMS, 4,
                                            ADDR CompareFunc
                        INVOKE UpdatelParam
                        mov    FileNameSortOrder, 4
                    .ENDIF                                        
                .ENDIF

ASSUME edi: PTR NMHDR

            .ELSEIF [edi].code==NM_DBLCLK
                INVOKE ShowCurrentFocus
            .ENDIF
        .ENDIF
        pop edi
    .ELSEIF uMsg==WM_SIZE
        movzx  eax, WORD PTR lParam
        movzx  edx, WORD PTR lParam + 2
        INVOKE MoveWindow, hList, 0, 0, eax, edx, TRUE
    .ELSEIF uMsg==WM_DESTROY
        INVOKE PostQuitMessage, NULL
    .ELSE
        INVOKE DefWindowProc, hWnd, uMsg, wParam, lParam        
        ret
    .ENDIF

    xor eax, eax
    ret

WndProc ENDP

END start
